/* misc.h - 02 Sep 09
   Hosts3D - 3D Real-Time Network Monitor
   Copyright (c) 2006-2009  Del Castle

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details. */

#include <dirent.h>  //dirent (linux), mkdir() (win)
#include <sys/time.h>  //timeval

#ifdef __MINGW32__
typedef unsigned int in_addr_t;
#endif

const double RAD = 0.0174532925;  //radians in a degree
const unsigned char white[] = {255, 255, 255},  //white
                    brred[] = {255, 50, 50},  //bright red
                    red[] = {200, 50, 50},  //red
                    orange[] = {220, 170, 50},  //orange
                    yellow[] = {200, 200, 50},  //yellow
                    fluro[] = {170, 220, 50},  //fluro
                    green[] = {50, 200, 50},  //green
                    mint[] = {50, 220, 170},  //mint
                    aqua[] = {50, 200, 200},  //aqua
                    sky[] = {50, 170, 220},  //sky
                    blue[] = {50, 50, 200},  //blue
                    purple[] = {170, 50, 220},  //purple
                    violet[] = {200, 50, 200},  //violet
                    brgrey[] = {200, 200, 200},  //bright grey
                    grey[] = {150, 150, 150},  //grey
                    dlgrey[] = {100, 100, 100};  //dull grey

//add extension to file
void extensionAdd(char *fl, const char *ex);

//check if file exists
bool fileExists(const char *fl);

//create directory file list
void filelistCreate(const char* fl, const char *ex);

//format bytes into units
char *formatBytes(unsigned long long bs, char *fb);

//check if an IP address is in a CIDR net
bool inNet(char *nt, char *ip);

//convert timeval to time in microseconds
unsigned long long microTime(const timeval *tv);

//convert timeval to time in milliseconds
unsigned long long milliTime(const timeval *tv);

//protocol number to string
char *protoDecode(unsigned char pr, char *pd);

//escape quotes in CSV strings
void quotecsv(const char *cs, char *ec);

#ifndef __MINGW32__
//check for regular file
int regFile(const dirent *ep);
#endif

//square function
double sqr(double x);

//convert string to lowercase
char *strLower(const char *ms, char *ls);
